package net.mcreator.bloonsballoons.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.6.5
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modelcustom_model<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("bloons_balloons", "modelcustom_model"),
			"main");
	public final ModelPart neck;
	public final ModelPart body;
	public final ModelPart wing;
	public final ModelPart wing1;
	public final ModelPart rearleg;
	public final ModelPart rearleg1;
	public final ModelPart frontleg;
	public final ModelPart frontleg1;
	public final ModelPart tail;
	public final ModelPart bb_main;

	public Modelcustom_model(ModelPart root) {
		this.neck = root.getChild("neck");
		this.body = root.getChild("body");
		this.wing = root.getChild("wing");
		this.wing1 = root.getChild("wing1");
		this.rearleg = root.getChild("rearleg");
		this.rearleg1 = root.getChild("rearleg1");
		this.frontleg = root.getChild("frontleg");
		this.frontleg1 = root.getChild("frontleg1");
		this.tail = root.getChild("tail");
		this.bb_main = root.getChild("bb_main");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition neck = partdefinition.addOrReplaceChild("neck", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 17.0F, -8.0F, -0.0873F, 0.0F, 0.0F));
		PartDefinition neck2 = neck.addOrReplaceChild("neck2", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 0.0F, -10.0F, 0.0873F, 0.0F, 0.0F));
		PartDefinition neck3 = neck2.addOrReplaceChild("neck3", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 0.0F, -10.0F, 0.0873F, 0.0F, 0.0F));
		PartDefinition neck4 = neck3.addOrReplaceChild("neck4", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 0.0F, -10.0F, 0.0873F, 0.0F, 0.0F));
		PartDefinition neck5 = neck4.addOrReplaceChild("neck5", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 0.0F, -10.0F, 0.0873F, 0.0F, 0.0F));
		PartDefinition head = neck5.addOrReplaceChild("head", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 0.0F, -10.0F, 0.0873F, 0.0F, 0.0F));
		PartDefinition head_r1 = head.addOrReplaceChild("head_r1",
				CubeListBuilder.create().texOffs(0, 92).addBox(-38.0F, -135.5137F, -222.9594F, 23.0F, 15.0F, 30.0F, new CubeDeformation(0.0F))
						.texOffs(0, 0).addBox(-48.0F, -175.5137F, -164.9594F, 38.0F, 30.0F, 62.0F, new CubeDeformation(0.0F)).texOffs(380, 504)
						.addBox(-50.0F, -119.5137F, -258.9594F, 104.0F, 32.0F, 88.0F, new CubeDeformation(0.0F)).texOffs(0, 0).mirror()
						.addBox(10.0F, -175.5137F, -164.9594F, 38.0F, 30.0F, 62.0F, new CubeDeformation(0.0F)).mirror(false).texOffs(0, 492)
						.addBox(-59.0F, -146.5137F, -171.9594F, 118.0F, 118.0F, 72.0F, new CubeDeformation(0.0F)).texOffs(106, 92)
						.addBox(15.0F, -135.5137F, -222.9594F, 23.0F, 15.0F, 30.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 7.0F, 58.0F, -0.3491F, 0.0F, 0.0F));
		PartDefinition jaw = head.addOrReplaceChild("jaw", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 4.0F, -13.0F, 0.2618F, 0.0F, 0.0F));
		PartDefinition body = partdefinition.addOrReplaceChild("body",
				CubeListBuilder.create().texOffs(0, 0).addBox(-59.0F, -142.0F, -108.0F, 118.0F, 118.0F, 241.0F, new CubeDeformation(0.0F))
						.texOffs(0, 20).addBox(-1.0F, -148.0F, -10.0F, 2.0F, 6.0F, 12.0F, new CubeDeformation(0.0F)).texOffs(0, 20)
						.addBox(-1.0F, -148.0F, 10.0F, 2.0F, 6.0F, 12.0F, new CubeDeformation(0.0F)).texOffs(0, 20)
						.addBox(-1.0F, -148.0F, 30.0F, 2.0F, 6.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 4.0F, 8.0F));
		PartDefinition wing = partdefinition.addOrReplaceChild("wing", CubeListBuilder.create(),
				PartPose.offsetAndRotation(95.0F, 5.0F, 2.0F, 0.0F, 0.1745F, 0.1745F));
		PartDefinition wing_r1 = wing.addOrReplaceChild("wing_r1",
				CubeListBuilder.create().texOffs(0, 359).addBox(-298.3677F, -82.1175F, 11.0853F, 121.0F, 12.0F, 121.0F, new CubeDeformation(0.01F))
						.texOffs(477, 134).addBox(-298.3677F, -98.1175F, -32.9147F, 121.0F, 43.0F, 43.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(12.0F, 19.0F, -2.0F, -0.0297F, -0.1719F, -0.0027F));
		PartDefinition wingtip = wing.addOrReplaceChild("wingtip", CubeListBuilder.create(),
				PartPose.offsetAndRotation(-56.0F, 0.0F, -2.0F, 0.0F, 0.0F, -0.3491F));
		PartDefinition wingtip_r1 = wingtip.addOrReplaceChild("wingtip_r1",
				CubeListBuilder.create().texOffs(477, 0).addBox(-375.9116F, -155.5938F, 10.0853F, 113.0F, 12.0F, 122.0F, new CubeDeformation(0.01F))
						.texOffs(588, 624).addBox(-376.9116F, -169.5938F, -29.9147F, 126.0F, 39.0F, 39.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(68.0F, 19.0F, 0.0F, 0.0315F, -0.1716F, -0.008F));
		PartDefinition wing1 = partdefinition.addOrReplaceChild("wing1", CubeListBuilder.create(),
				PartPose.offsetAndRotation(12.0F, 5.0F, 2.0F, 0.0F, -0.1745F, -0.1745F));
		PartDefinition wing2_r1 = wing1.addOrReplaceChild("wing2_r1",
				CubeListBuilder.create().texOffs(469, 0).mirror()
						.addBox(146.3047F, -159.3087F, -15.4774F, 121.0F, 12.0F, 121.0F, new CubeDeformation(0.01F)).mirror(false),
				PartPose.offsetAndRotation(-12.0F, 19.0F, -2.0F, 0.0315F, 0.1716F, 0.3571F));
		PartDefinition wing1_r1 = wing1.addOrReplaceChild("wing1_r1",
				CubeListBuilder.create().texOffs(469, 0).addBox(71.4618F, -100.6161F, -15.4774F, 121.0F, 12.0F, 121.0F, new CubeDeformation(0.01F))
						.texOffs(477, 134).mirror().addBox(70.9519F, -119.1175F, -32.9147F, 121.0F, 43.0F, 43.0F, new CubeDeformation(0.0F))
						.mirror(false),
				PartPose.offsetAndRotation(-12.0F, 19.0F, -2.0F, -0.0297F, 0.1719F, 0.0027F));
		PartDefinition wingtip1 = wing1.addOrReplaceChild("wingtip1", CubeListBuilder.create(),
				PartPose.offsetAndRotation(56.0F, 0.0F, -2.0F, 0.0F, 0.0F, 0.3491F));
		PartDefinition wingtip1_r1 = wingtip1.addOrReplaceChild("wingtip1_r1",
				CubeListBuilder.create().texOffs(588, 624).mirror()
						.addBox(151.7395F, -154.2208F, -29.4774F, 126.0F, 39.0F, 39.0F, new CubeDeformation(0.0F)).mirror(false),
				PartPose.offsetAndRotation(-68.0F, 19.0F, 0.0F, 0.0315F, 0.1716F, 0.008F));
		PartDefinition rearleg = partdefinition.addOrReplaceChild("rearleg", CubeListBuilder.create(),
				PartPose.offsetAndRotation(-16.0F, 16.0F, 42.0F, 1.0472F, 0.0F, 0.0F));
		PartDefinition rearlegtip = rearleg.addOrReplaceChild("rearlegtip", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 28.0F, 1.0F, 0.4363F, 0.0F, 0.0F));
		PartDefinition rearfoot = rearlegtip.addOrReplaceChild("rearfoot", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 32.0F, -2.0F, 0.7854F, 0.0F, 0.0F));
		PartDefinition rearleg1 = partdefinition.addOrReplaceChild("rearleg1", CubeListBuilder.create(),
				PartPose.offsetAndRotation(16.0F, 16.0F, 42.0F, 1.0472F, 0.0F, 0.0F));
		PartDefinition rearlegtip1 = rearleg1.addOrReplaceChild("rearlegtip1", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 28.0F, 1.0F, 0.4363F, 0.0F, 0.0F));
		PartDefinition rearfoot1 = rearlegtip1.addOrReplaceChild("rearfoot1", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 32.0F, -2.0F, 0.7854F, 0.0F, 0.0F));
		PartDefinition frontleg = partdefinition.addOrReplaceChild("frontleg", CubeListBuilder.create(),
				PartPose.offsetAndRotation(-12.0F, 20.0F, 2.0F, 1.1345F, 0.0F, 0.0F));
		PartDefinition frontlegtip = frontleg.addOrReplaceChild("frontlegtip", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 20.0F, 0.0F, -0.3491F, 0.0F, 0.0F));
		PartDefinition frontfoot = frontlegtip.addOrReplaceChild("frontfoot", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 22.0F, 0.0F, 0.7854F, 0.0F, 0.0F));
		PartDefinition frontleg1 = partdefinition.addOrReplaceChild("frontleg1", CubeListBuilder.create(),
				PartPose.offsetAndRotation(12.0F, 20.0F, 2.0F, 1.1345F, 0.0F, 0.0F));
		PartDefinition frontlegtip1 = frontleg1.addOrReplaceChild("frontlegtip1", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 20.0F, 0.0F, -0.3491F, 0.0F, 0.0F));
		PartDefinition frontfoot1 = frontlegtip1.addOrReplaceChild("frontfoot1", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 22.0F, 0.0F, 0.7854F, 0.0F, 0.0F));
		PartDefinition tail = partdefinition.addOrReplaceChild(
				"tail", CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -53.0F, 84.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -57.0F, 86.0F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -23.0F, 56.0F));
		PartDefinition tail2 = tail.addOrReplaceChild("tail2",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -51.5267F, 84.8249F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -55.5267F, 86.8249F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.0175F, 0.0F, 0.0F));
		PartDefinition tail3 = tail2.addOrReplaceChild("tail3",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -50.0392F, 85.624F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -54.0392F, 87.624F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.0175F, 0.0F, 0.0F));
		PartDefinition tail4 = tail3.addOrReplaceChild("tail4",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -48.538F, 86.397F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -52.538F, 88.397F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.0175F, 0.0F, 0.0F));
		PartDefinition tail5 = tail4.addOrReplaceChild("tail5",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -45.4963F, 87.8638F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -49.4963F, 89.8638F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.0349F, 0.0F, 0.0F));
		PartDefinition tail6 = tail5.addOrReplaceChild("tail6",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -40.8423F, 89.8628F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -44.8423F, 91.8628F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.0524F, 0.0F, 0.0F));
		PartDefinition tail7 = tail6.addOrReplaceChild("tail7",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -36.0901F, 91.6155F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -40.0901F, 93.6155F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.0524F, 0.0F, 0.0F));
		PartDefinition tail8 = tail7.addOrReplaceChild("tail8",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -34.4865F, 92.1442F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -38.4865F, 94.1442F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.0175F, 0.0F, 0.0F));
		PartDefinition tail9 = tail8.addOrReplaceChild("tail9",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -36.0901F, 91.6155F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -40.0901F, 93.6155F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, -0.0175F, 0.0F, 0.0F));
		PartDefinition tail10 = tail9.addOrReplaceChild("tail10",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -39.2685F, 90.4747F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -43.2685F, 92.4747F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, -0.0349F, 0.0F, 0.0F));
		PartDefinition tail11 = tail10.addOrReplaceChild("tail11",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -43.9567F, 88.5572F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -47.9567F, 90.5572F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, -0.0524F, 0.0F, 0.0F));
		PartDefinition tail12 = tail11.addOrReplaceChild("tail12",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -48.538F, 86.397F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F))
						.texOffs(16, 20).addBox(-1.0F, -52.538F, 88.397F, 2.0F, 4.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, -0.0524F, 0.0F, 0.0F));
		PartDefinition bb_main = partdefinition.addOrReplaceChild("bb_main", CubeListBuilder.create(), PartPose.offset(0.0F, 24.0F, 0.0F));
		PartDefinition jaw_r1 = bb_main.addOrReplaceChild("jaw_r1",
				CubeListBuilder.create().texOffs(294, 624).addBox(-50.0F, -134.5041F, -237.0748F, 104.0F, 25.0F, 86.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.1745F, 0.0F, 0.0F));
		return LayerDefinition.create(meshdefinition, 1024, 1024);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green,
			float blue, float alpha) {
		neck.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		wing.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		wing1.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		rearleg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		rearleg1.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		frontleg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		frontleg1.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		tail.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		bb_main.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
		this.wing1.yRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.wing.yRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
	}
}
