// Made with Blockbench 4.7.2
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelt4dm<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "t4dm"), "main");
	private final ModelPart monkey;
	private final ModelPart catapult;

	public Modelt4dm(ModelPart root) {
		this.monkey = root.getChild("monkey");
		this.catapult = root.getChild("catapult");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition monkey = partdefinition.addOrReplaceChild("monkey",
				CubeListBuilder.create().texOffs(50, 42)
						.addBox(36.0F, -1.0F, -2.0F, 2.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(35, 28)
						.addBox(40.0F, -1.0F, -2.0F, 2.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(34, 0)
						.addBox(40.0F, -5.0F, -1.0F, 2.0F, 4.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(10, 14)
						.addBox(36.0F, -5.0F, -1.0F, 2.0F, 4.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(36.0F, -15.0F, -2.0F, 6.0F, 10.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(0, 67)
						.addBox(35.0F, -23.0F, -3.0F, 8.0F, 8.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-18.0F, 24.0F, 0.0F));

		PartDefinition cube_r1 = monkey
				.addOrReplaceChild("cube_r1",
						CubeListBuilder.create().texOffs(0, 14).addBox(-3.0F, -4.0F, 5.5F, 1.0F, 1.0F, 4.0F,
								new CubeDeformation(0.0F)),
						PartPose.offsetAndRotation(39.0F, 0.0F, 0.0F, 0.0F, 0.48F, 0.0F));

		PartDefinition cube_r2 = monkey.addOrReplaceChild("cube_r2",
				CubeListBuilder.create().texOffs(24, 12)
						.addBox(0.0F, -6.0F, -1.0F, 1.0F, 1.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(24, 0)
						.addBox(-0.5F, -25.0F, -6.0F, 1.0F, 3.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(24, 12)
						.addBox(0.5F, -24.0F, -6.0F, 1.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(39.0F, 0.0F, 0.0F, -0.3491F, 0.0F, 0.0F));

		PartDefinition cube_r3 = monkey.addOrReplaceChild("cube_r3",
				CubeListBuilder.create().texOffs(0, 22)
						.addBox(-6.0F, -13.0F, -1.0F, 2.0F, 7.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(0, 52)
						.addBox(2.0F, -19.0F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(39.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0873F));

		PartDefinition cube_r4 = monkey.addOrReplaceChild("cube_r4",
				CubeListBuilder.create().texOffs(30, 22)
						.addBox(4.0F, -13.0F, -1.0F, 2.0F, 7.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(38, 22)
						.addBox(-4.0F, -19.0F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(39.0F, 0.0F, 0.0F, 0.0F, 0.0F, -0.0873F));

		PartDefinition catapult = partdefinition.addOrReplaceChild("catapult",
				CubeListBuilder.create().texOffs(52, 73)
						.addBox(8.0F, -18.0F, -4.6F, 2.0F, 11.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(8.0F, -7.0F, -23.0F, 2.0F, 6.0F, 46.0F, new CubeDeformation(0.0F)).texOffs(50, 6)
						.addBox(26.0F, -7.0F, -23.0F, 2.0F, 6.0F, 46.0F, new CubeDeformation(0.0F)).texOffs(44, 73)
						.addBox(26.0F, -18.0F, -4.6F, 2.0F, 11.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(50, 38)
						.addBox(10.0F, -18.0F, -4.6F, 16.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(0, 39)
						.addBox(10.0F, -9.0F, -4.6F, 21.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(38, 10)
						.addBox(31.0F, -13.0F, -4.6F, 1.0F, 6.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(6, 14)
						.addBox(32.0F, -12.5F, -4.0F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-18.0F, 24.0F, 0.0F));

		PartDefinition cube_r5 = catapult.addOrReplaceChild("cube_r5",
				CubeListBuilder.create().texOffs(0, 22)
						.addBox(13.0F, -16.0F, 21.0F, 10.0F, 7.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(38, 62)
						.addBox(13.0F, -6.5F, 21.0F, 10.0F, 1.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(0, 52)
						.addBox(12.0F, -9.5F, 20.0F, 12.0F, 3.0F, 12.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(17.0F, -9.5F, 0.7F, 2.0F, 2.0F, 20.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.48F, 0.0F, 0.0F));

		PartDefinition cube_r6 = catapult.addOrReplaceChild("cube_r6",
				CubeListBuilder.create().texOffs(50, 21)
						.addBox(26.0F, -15.0F, -5.0F, 2.0F, 2.0F, 15.0F, new CubeDeformation(0.0F)).texOffs(50, 4)
						.addBox(8.0F, -15.0F, -5.0F, 2.0F, 2.0F, 15.0F, new CubeDeformation(0.0F)).texOffs(50, 21)
						.addBox(26.0F, -13.0F, 8.0F, 2.0F, 13.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(50, 4)
						.addBox(8.0F, -13.0F, 8.0F, 2.0F, 13.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(69, 21)
						.addBox(6.0F, 6.0F, 12.0F, 2.0F, 6.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(69, 4)
						.addBox(28.0F, 6.0F, 12.0F, 2.0F, 6.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(50, 0)
						.addBox(5.0F, 8.0F, 14.0F, 26.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(28, 67)
						.addBox(28.0F, -18.0F, -12.0F, 2.0F, 6.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(24, 0)
						.addBox(6.0F, -18.0F, -12.0F, 2.0F, 6.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(36, 58)
						.addBox(5.0F, -16.0F, -10.0F, 26.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.7854F, 0.0F, 0.0F));

		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	@Override
	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {

	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		monkey.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		catapult.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}
}