package net.mcreator.bloonsballoons.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.4.1
// Exported for Minecraft version 1.17 - 1.18 with Mojang mappings
// Paste this class into your mod and generate all required imports
public class ModelZOMG<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("bloons_balloons", "model_zomg"), "main");
	public final ModelPart bb_main;

	public ModelZOMG(ModelPart root) {
		this.bb_main = root.getChild("bb_main");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition bb_main = partdefinition.addOrReplaceChild("bb_main",
				CubeListBuilder.create().texOffs(0, 0).addBox(-32.0F, -74.0F, -34.0F, 64.0F, 64.0F, 71.0F, new CubeDeformation(0.0F)).texOffs(0, 135)
						.addBox(-31.0F, -73.0F, 31.0F, 62.0F, 62.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(138, 135)
						.addBox(-30.0F, -72.0F, 32.0F, 60.0F, 60.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(199, 0)
						.addBox(-29.0F, -71.0F, 33.0F, 58.0F, 58.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(0, 204)
						.addBox(-28.0F, -70.0F, 34.0F, 56.0F, 56.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(257, 264)
						.addBox(-27.0F, -69.0F, 35.0F, 54.0F, 54.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(0, 267)
						.addBox(-26.0F, -68.0F, 36.0F, 52.0F, 52.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(272, 123)
						.addBox(-25.0F, -67.0F, 37.0F, 50.0F, 50.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(0, 326)
						.addBox(-24.0F, -66.0F, 38.0F, 48.0F, 48.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(329, 0)
						.addBox(-23.0F, -65.0F, 39.0F, 46.0F, 46.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(354, 325)
						.addBox(-22.0F, -64.0F, 40.0F, 44.0F, 44.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(379, 264)
						.addBox(-21.0F, -63.0F, 41.0F, 42.0F, 42.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(0, 381)
						.addBox(-20.0F, -62.0F, 42.0F, 40.0F, 40.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(386, 53)
						.addBox(-19.0F, -61.0F, 43.0F, 38.0F, 38.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(368, 426)
						.addBox(-18.0F, -60.0F, 44.0F, 36.0F, 36.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(0, 428)
						.addBox(-17.0F, -59.0F, 45.0F, 34.0F, 34.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(435, 0)
						.addBox(-16.0F, -58.0F, 46.0F, 32.0F, 32.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(451, 193)
						.addBox(-15.0F, -57.0F, 47.0F, 30.0F, 30.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(0, 35)
						.addBox(-14.0F, -56.0F, 48.0F, 28.0F, 28.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(454, 409)
						.addBox(-13.0F, -55.0F, 49.0F, 26.0F, 26.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(456, 313)
						.addBox(-12.0F, -54.0F, 50.0F, 24.0F, 24.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(456, 344)
						.addBox(-11.0F, -53.0F, 51.0F, 22.0F, 22.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(460, 230)
						.addBox(-10.0F, -52.0F, 52.0F, 20.0F, 20.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(0, 469)
						.addBox(-9.0F, -51.0F, 53.0F, 18.0F, 18.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(210, 469)
						.addBox(-8.0F, -50.0F, 54.0F, 16.0F, 16.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(469, 39)
						.addBox(-7.0F, -49.0F, 55.0F, 14.0F, 14.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(160, 428)
						.addBox(-6.0F, -48.0F, 56.0F, 12.0F, 12.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(394, 469)
						.addBox(-5.0F, -47.0F, 57.0F, 10.0F, 10.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(296, 381)
						.addBox(-4.0F, -46.0F, 58.0F, 8.0F, 8.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(354, 180)
						.addBox(-3.0F, -45.0F, 59.0F, 6.0F, 6.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(316, 183)
						.addBox(21.0F, -36.0F, 34.0F, 14.0F, 8.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(316, 183)
						.addBox(-35.0F, -36.0F, 34.0F, 14.0F, 8.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(138, 447)
						.addBox(-49.0F, -39.0F, 24.0F, 14.0F, 14.0F, 22.0F, new CubeDeformation(0.0F)).texOffs(138, 447)
						.addBox(35.0F, -39.0F, 24.0F, 14.0F, 14.0F, 22.0F, new CubeDeformation(0.0F)).texOffs(272, 180)
						.addBox(-52.0F, -33.0F, 23.0F, 20.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(136, 202)
						.addBox(-31.0F, -73.0F, -36.0F, 62.0F, 62.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(264, 202)
						.addBox(-30.0F, -72.0F, -38.0F, 60.0F, 60.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(124, 266)
						.addBox(-29.0F, -71.0F, -40.0F, 58.0F, 58.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(270, 65)
						.addBox(-28.0F, -70.0F, -42.0F, 56.0F, 56.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(242, 325)
						.addBox(-27.0F, -69.0F, -44.0F, 54.0F, 54.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(110, 326)
						.addBox(-26.0F, -68.0F, -46.0F, 52.0F, 52.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(354, 376)
						.addBox(-24.0F, -66.0F, -48.0F, 48.0F, 48.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(108, 380)
						.addBox(-23.0F, -65.0F, -50.0F, 46.0F, 46.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(204, 381)
						.addBox(-22.0F, -64.0F, -52.0F, 44.0F, 44.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(386, 98)
						.addBox(-21.0F, -63.0F, -54.0F, 42.0F, 42.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(202, 427)
						.addBox(-20.0F, -62.0F, -56.0F, 40.0F, 40.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(82, 428)
						.addBox(-19.0F, -61.0F, -57.0F, 38.0F, 38.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(286, 454)
						.addBox(-18.0F, -60.0F, -58.0F, 36.0F, 36.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(-17.0F, -59.0F, -59.0F, 34.0F, 34.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(454, 376)
						.addBox(-16.0F, -58.0F, -60.0F, 32.0F, 32.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(454, 442)
						.addBox(-15.0F, -57.0F, -61.0F, 30.0F, 30.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(428, 142)
						.addBox(-14.0F, -56.0F, -62.0F, 28.0F, 28.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(82, 467)
						.addBox(-12.0F, -54.0F, -63.0F, 24.0F, 24.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(458, 171)
						.addBox(-10.0F, -52.0F, -64.0F, 20.0F, 20.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(360, 469)
						.addBox(-8.0F, -50.0F, -65.0F, 16.0F, 16.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(218, 326)
						.addBox(-5.0F, -47.0F, -66.0F, 10.0F, 10.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(131, 135)
						.addBox(-2.0F, -44.0F, -67.0F, 4.0F, 4.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(272, 180)
						.addBox(33.0F, -33.0F, 23.0F, 20.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 24.0F, 0.0F));
		PartDefinition cube_r1 = bb_main.addOrReplaceChild("cube_r1",
				CubeListBuilder.create().texOffs(386, 142).addBox(18.0F, -1.0F, -3.0F, 6.0F, 28.0F, 30.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -12.0F, 51.0F, -0.6545F, 0.0F, -0.7854F));
		PartDefinition cube_r2 = bb_main.addOrReplaceChild("cube_r2",
				CubeListBuilder.create().texOffs(388, 200).addBox(17.0F, -33.0F, 1.0F, 6.0F, 28.0F, 30.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -12.0F, 51.0F, 0.7854F, 0.0F, -2.1817F));
		PartDefinition cube_r3 = bb_main.addOrReplaceChild("cube_r3",
				CubeListBuilder.create().texOffs(296, 396).addBox(-3.0F, -53.0F, 23.0F, 6.0F, 28.0F, 30.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -12.0F, 51.0F, 0.7854F, 0.0F, 0.0F));
		return LayerDefinition.create(meshdefinition, 1024, 1024);
	}

	@Override
	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green,
			float blue, float alpha) {
		bb_main.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}
}
